import { Command, CommandLine, CommandUtil, Spawn } from 'firmament-yargs';
import { DockerImageManagement } from '../../interfaces/docker-image-management';
import { DockerContainerManagement } from '../../interfaces/docker-container-management';
import { DockerMake } from '../../interfaces/docker-make';
export declare class DockerCommandImpl implements Command {
    private commandUtil;
    private spawn;
    private dockerMake;
    private dockerImageManagement;
    private dockerContainerManagement;
    private commandLine;
    aliases: string[];
    command: string;
    commandDesc: string;
    handler: (argv: any) => void;
    options: any;
    subCommands: Command[];
    constructor(commandUtil: CommandUtil, spawn: Spawn, dockerMake: DockerMake, dockerImageManagement: DockerImageManagement, dockerContainerManagement: DockerContainerManagement, commandLine: CommandLine);
    private buildCommandTree;
    private pushSaveImagesCommand;
    private pushLoadImagesCommand;
    private pushCleanVolumesCommand;
    private pushRemoveImagesCommand;
    private pushRemoveContainersCommand;
    private pushShellCommand;
    private pushStartCommand;
    private startOrStopContainers;
    private pushStopCommand;
    private pushImagesCommand;
    private pushPsCommand;
    private printImagesList;
    private printContainerList;
    private bashInToContainer;
    private prettyPrintDockerImagesList;
    private prettyPrintDockerContainerList;
}
