import { DockerImageManagement } from '../interfaces/docker-image-management';
import { DockerImage, ImageOrContainerRemoveResults } from '..';
import { ForceErrorImpl, CommandUtil, Spawn, SafeJson } from 'firmament-yargs';
import { DockerManagement } from '../interfaces/docker-management';
export declare class DockerImageManagementImpl extends ForceErrorImpl implements DockerImageManagement {
    private DM;
    private spawn;
    private safeJson;
    private commandUtil;
    constructor(DM: DockerManagement, spawn: Spawn, safeJson: SafeJson, commandUtil: CommandUtil);
    loadImages(imageRegEx: string, inputFolder: string, cb: (err: Error) => void): void;
    saveImages(imageRegEx: string, outputFolder: string, cb: (err: Error) => void): void;
    listImages(listAllImages: boolean, cb: (err: Error, images: DockerImage[]) => void): void;
    getImages(ids: string[], cb: (err: Error, images: DockerImage[]) => void): void;
    getImage(id: string, cb: (err: Error, image: DockerImage) => void): void;
    removeImages(ids: string[], cb: (err: Error, imageRemoveResults: ImageOrContainerRemoveResults[]) => void): void;
    pullImage(imageName: string, progressCb: (taskId: string, status: string, current: number, total: number) => void, cb: (err: Error) => void): void;
    buildDockerFile(dockerFilePath: string, dockerImageName: string, progressCb: (taskId: string, status: string, current: number, total: number) => void, cb: (err: Error) => void): void;
}
