import { DockerMake } from '../interfaces/docker-make';
import { Positive, CommandUtil, ProgressBar, Spawn, ForceErrorImpl } from 'firmament-yargs';
import { DockerContainerManagement } from '../interfaces/docker-container-management';
import { DockerImageManagement } from '../interfaces/docker-image-management';
import { RemoteCatalogGetter, SafeJson } from 'firmament-yargs';
import { DockerUtil } from "../interfaces/docker-util";
export declare class DockerMakeImpl extends ForceErrorImpl implements DockerMake {
    private commandUtil;
    private spawn;
    private safeJson;
    private remoteCatalogGetter;
    private dockerImageManagement;
    dockerUtil: DockerUtil;
    private dockerContainerManagement;
    private positive;
    private progressBar;
    constructor(commandUtil: CommandUtil, spawn: Spawn, safeJson: SafeJson, remoteCatalogGetter: RemoteCatalogGetter, dockerImageManagement: DockerImageManagement, dockerUtil: DockerUtil, dockerContainerManagement: DockerContainerManagement, positive: Positive, progressBar: ProgressBar);
    buildTemplate(argv: any): void;
    makeTemplate(argv: any): void;
    getSortedContainerConfigsFromJsonFile(inputPath: string): {
        fullInputPath: any;
        sortedContainerConfigs: any[];
    };
    private processContainerConfigs;
    private containerDependencySort;
    private topologicalDependencySort;
    private remoteSlcCtlCommand;
    private gitClone;
}
