import { DockerUtil } from '../../interfaces/docker-util';
import { DockerOde, DockerImageOrContainer, ImageOrContainerRemoveResults } from '../..';
import { CommandUtil, Positive, Spawn, SafeJson } from 'firmament-yargs';
import { DockerUtilOptions } from '../../interfaces/docker-util-options';
import { ForceErrorImpl } from 'firmament-yargs';
export declare class DockerUtilImpl extends ForceErrorImpl implements DockerUtil {
    private dockerode;
    private positive;
    private safeJson;
    private spawn;
    private commandUtil;
    constructor(dockerode: DockerOde, positive: Positive, safeJson: SafeJson, spawn: Spawn, commandUtil: CommandUtil);
    writeJsonTemplateFile(objectToWrite: any, fullOutputPath: string): void;
    listImagesOrContainers(options: DockerUtilOptions, cb: (err: Error, imagesOrContainers: any[]) => void): void;
    getImagesOrContainers(ids: string[], options: DockerUtilOptions, cb: (err: Error, imagesOrContainers: DockerImageOrContainer[]) => void): void;
    getImageOrContainer(id: string, options: DockerUtilOptions, cb: (err: Error, imageOrContainer: any) => void): void;
    removeImagesOrContainers(ids: string[], options: DockerUtilOptions, cb: (err: Error, imageOrContainerRemoveResults: ImageOrContainerRemoveResults[]) => void): void;
    private static compareIds;
    private static stripSha256;
    private logErrAndResult;
}
