import {kernel} from 'firmament-bash';
import {Command} from 'firmament-yargs';
import {DockerImageManagement} from './interfaces/docker-image-management';
import {DockerImageManagementImpl} from './implementations/docker-image-management-impl';
import {DockerOde} from './interfaces/dockerode';
import {DockerOdeImpl} from './implementations/util/docker-ode-impl';
import {DockerUtil} from './interfaces/docker-util';
import {DockerUtilImpl} from './implementations/util/docker-util-impl';
import {DockerContainerManagement} from './interfaces/docker-container-management';
import {DockerContainerManagementImpl} from './implementations/docker-container-management-impl';
import {DockerCommandImpl} from './implementations/commands/docker-command-impl';
import {MakeCommandImpl} from './implementations/commands/make-command-impl';
import {DockerManagement} from './interfaces/docker-management';
import {DockerManagementImpl} from './implementations/docker-management-impl';
import {DockerMakeImpl} from './implementations/docker-make-impl';
import {DockerMake} from './interfaces/docker-make';
import {ProvisionCommandImpl} from './implementations/commands/provision-command-impl';
import {DockerProvision} from './interfaces/docker-provision';
import {DockerProvisionImpl} from './implementations/docker-provision-impl';
import {VmwareCommandImpl} from "./implementations/commands/vmware-command-impl";
import {VmwareMake} from "./interfaces/vmware-make";
import {VmwareMakeImpl} from "./implementations/vmware-make-impl";

kernel.bind<DockerManagement>('DockerManagement').to(DockerManagementImpl).inSingletonScope();
kernel.bind<DockerMake>('DockerMake').to(DockerMakeImpl).inSingletonScope();
kernel.bind<VmwareMake>('VmwareMake').to(VmwareMakeImpl).inSingletonScope();
kernel.bind<DockerProvision>('DockerProvision').to(DockerProvisionImpl).inSingletonScope();
kernel.bind<DockerImageManagement>('DockerImageManagement').to(DockerImageManagementImpl).inSingletonScope();
kernel.bind<DockerContainerManagement>('DockerContainerManagement').to(DockerContainerManagementImpl).inSingletonScope();
kernel.bind<DockerOde>('DockerOde').to(DockerOdeImpl).inSingletonScope();
kernel.bind<DockerUtil>('DockerUtil').to(DockerUtilImpl).inSingletonScope();
kernel.bind<Command>('Command').to(DockerCommandImpl).inSingletonScope();
kernel.bind<Command>('Command').to(MakeCommandImpl).inSingletonScope();
kernel.bind<Command>('Command').to(VmwareCommandImpl).inSingletonScope();
kernel.bind<Command>('Command').to(ProvisionCommandImpl).inSingletonScope();

export default kernel;
